package cn.com.infosec.crypto.tls;

import cn.com.infosec.crypto.digests.SHA1Digest;
import cn.com.infosec.crypto.engines.AESFastEngine;
import cn.com.infosec.crypto.engines.DESedeEngine;
import cn.com.infosec.crypto.modes.CBCBlockCipher;
import java.io.OutputStream;

public class TlsCipherSuiteManager {
   private static final int TLS_RSA_WITH_3DES_EDE_CBC_SHA = 10;
   private static final int TLS_DHE_RSA_WITH_3DES_EDE_CBC_SHA = 22;
   private static final int TLS_RSA_WITH_AES_128_CBC_SHA = 47;
   private static final int TLS_DHE_RSA_WITH_AES_128_CBC_SHA = 51;
   private static final int TLS_RSA_WITH_AES_256_CBC_SHA = 53;
   private static final int TLS_DHE_RSA_WITH_AES_256_CBC_SHA = 57;

   protected static void writeCipherSuites(OutputStream os) {
      TlsUtils.writeUint16(12, os);
      TlsUtils.writeUint16(57, os);
      TlsUtils.writeUint16(51, os);
      TlsUtils.writeUint16(22, os);
      TlsUtils.writeUint16(53, os);
      TlsUtils.writeUint16(47, os);
      TlsUtils.writeUint16(10, os);
   }

   protected static TlsCipherSuite getCipherSuite(int number, TlsProtocolHandler handler) {
      CBCBlockCipher var10002;
      DESedeEngine var2;
      SHA1Digest var3;
      CBCBlockCipher number1;
      DESedeEngine handler1;
      CBCBlockCipher handler2;
      SHA1Digest var7;
      if (number != 10) {
         if (number != 22) {
            AESFastEngine handler3;
            AESFastEngine var9;
            if (number != 47) {
               if (number != 51) {
                  if (number != 53) {
                     if (number != 57) {
                        handler.failWithError((short)2, (short)40);
                        return null;
                     } else {
                        var10002 = number1 = new CBCBlockCipher;
                        handler3 = new AESFastEngine.<init>();
                        var10002.<init>(handler3);
                        var10002 = handler2 = new CBCBlockCipher;
                        var9 = new AESFastEngine.<init>();
                        var10002.<init>(var9);
                        var7 = new SHA1Digest.<init>();
                        var3 = new SHA1Digest.<init>();
                        return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 32, (short)5);
                     }
                  } else {
                     var10002 = number1 = new CBCBlockCipher;
                     handler3 = new AESFastEngine.<init>();
                     var10002.<init>(handler3);
                     var10002 = handler2 = new CBCBlockCipher;
                     var9 = new AESFastEngine.<init>();
                     var10002.<init>(var9);
                     var7 = new SHA1Digest.<init>();
                     var3 = new SHA1Digest.<init>();
                     return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 32, (short)1);
                  }
               } else {
                  var10002 = number1 = new CBCBlockCipher;
                  handler3 = new AESFastEngine.<init>();
                  var10002.<init>(handler3);
                  var10002 = handler2 = new CBCBlockCipher;
                  var9 = new AESFastEngine.<init>();
                  var10002.<init>(var9);
                  var7 = new SHA1Digest.<init>();
                  var3 = new SHA1Digest.<init>();
                  return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 16, (short)5);
               }
            } else {
               var10002 = number1 = new CBCBlockCipher;
               handler3 = new AESFastEngine.<init>();
               var10002.<init>(handler3);
               var10002 = handler2 = new CBCBlockCipher;
               var9 = new AESFastEngine.<init>();
               var10002.<init>(var9);
               var7 = new SHA1Digest.<init>();
               var3 = new SHA1Digest.<init>();
               return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 16, (short)1);
            }
         } else {
            var10002 = number1 = new CBCBlockCipher;
            handler1 = new DESedeEngine.<init>();
            var10002.<init>(handler1);
            var10002 = handler2 = new CBCBlockCipher;
            var2 = new DESedeEngine.<init>();
            var10002.<init>(var2);
            var7 = new SHA1Digest.<init>();
            var3 = new SHA1Digest.<init>();
            return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 24, (short)5);
         }
      } else {
         var10002 = number1 = new CBCBlockCipher;
         handler1 = new DESedeEngine.<init>();
         var10002.<init>(handler1);
         var10002 = handler2 = new CBCBlockCipher;
         var2 = new DESedeEngine.<init>();
         var10002.<init>(var2);
         var7 = new SHA1Digest.<init>();
         var3 = new SHA1Digest.<init>();
         return new TlsBlockCipherCipherSuite(number1, handler2, var7, var3, 24, (short)1);
      }
   }
}
